*** a/src/backend/access/transam/twophase.c
--- b/src/backend/access/transam/twophase.c
***************
*** 901,907 **** StartPrepare(GlobalTransaction gxact)
  	hdr.ncommitrels = smgrGetPendingDeletes(true, &commitrels);
  	hdr.nabortrels = smgrGetPendingDeletes(false, &abortrels);
  	hdr.ninvalmsgs = xactGetCommittedInvalidationMessages(&invalmsgs,
! 														  &hdr.initfileinval);
  	StrNCpy(hdr.gid, gxact->gid, GIDSIZE);
  
  	save_state_data(&hdr, sizeof(TwoPhaseFileHeader));
--- 901,907 ----
  	hdr.ncommitrels = smgrGetPendingDeletes(true, &commitrels);
  	hdr.nabortrels = smgrGetPendingDeletes(false, &abortrels);
  	hdr.ninvalmsgs = xactGetCommittedInvalidationMessages(&invalmsgs,
! 														  &hdr.initfileinval, false);
  	StrNCpy(hdr.gid, gxact->gid, GIDSIZE);
  
  	save_state_data(&hdr, sizeof(TwoPhaseFileHeader));
*** a/src/backend/access/transam/varsup.c
--- b/src/backend/access/transam/varsup.c
***************
*** 43,49 **** VariableCache ShmemVariableCache = NULL;
   * issue a warning about XID wrap.
   */
  TransactionId
! GetNewTransactionId(bool isSubXact)
  {
  	TransactionId xid;
  
--- 43,49 ----
   * issue a warning about XID wrap.
   */
  TransactionId
! GetNewTransactionId(bool isSubXact, int stateNestinglevel, int autotxlevel)
  {
  	TransactionId xid;
  
***************
*** 212,217 **** GetNewTransactionId(bool isSubXact)
--- 212,249 ----
  		volatile PGPROC *myproc = MyProc;
  		volatile PGXACT *mypgxact = MyPgXact;
  
+ 		if (autotxlevel > 0)
+ 		{
+ 			int		 nxids = 0;
+ 			int		 autoNestingLevel = 0;
+ 			volatile PGAutonomousXACT *mypgautonomoustx;
+ 			mypgautonomoustx = &MyPgAutonomousXact[autotxlevel-1];
+ 			autoNestingLevel = mypgautonomoustx->nestingLevel;
+ 
+ 			/* In top auto tx*/
+ 			if (stateNestinglevel == autoNestingLevel)
+ 			{
+ 				mypgautonomoustx->xid = xid;
+ 				LWLockRelease(XidGenLock);
+ 				return xid;
+ 			}
+ 
+ 			/* Subtransaction in auto tx */
+ 			Assert(autoNestingLevel < stateNestinglevel);
+ 
+ 			nxids = mypgautonomoustx->nxids;
+ 			if (nxids < PGPROC_MAX_CACHED_SUBXIDS)
+ 			{
+ 				mypgautonomoustx->subxids.xids[nxids] = xid;
+ 				mypgautonomoustx->nxids++;
+ 			}
+ 			else
+ 				mypgautonomoustx->overflowed = true;
+ 
+ 			LWLockRelease(XidGenLock);
+ 			return xid;
+ 		}
+ 
  		if (!isSubXact)
  			mypgxact->xid = xid;
  		else
